# Configuration Features

This page provides a complete list of the configuration features available.

The properties are identified by a symbolic name and a URI value defined in the Java module `FeatureKeys`. The table below gives summary information for each property, together with a link to the Javadoc, where more complete information is held.

Name and URI | Description | Command line option

`ALLOW_EXTERNAL_FUNCTIONS`

http://saxon.sf.net/feature/allow-external-functions

ALLOW_EXTERNAL_FUNCTIONS determines whether calls to reflexive external functions are allowed. More specifically, if set to false it disallows all of the following:

- Calls to reflexive Java extension functions

- Use of the XSLT system-property() function to access Java system properties

- Use of a relative URI in the `xsl:result-document` instruction

- Calls to XSLT extension instructions

The default value is true. The setting false is recommended in an environment where untrusted stylesheets may be executed.

This option does not disable use of the `doc()` function or similar functions to access the filestore of the machine where the transformation or query is running. That should be done using a user-supplied `URIResolver`

Note that integrated extension functions are trusted; calls to such functions are allowed even if this configuration option is false. In cases where an integrated extension function is used to load and execute untrusted code, it should check this configuration option before doing so.

-ext

`ALLOW_MULTITHREADING`

http://saxon.sf.net/feature/allow-multithreading

ALLOW_MULTITHREADING determines whether multi-threading is allowed.

If true (the default), the presence of the attribute `saxon:threads="N"` on an `xsl:for-each` instruction, when running under Saxon-EE, causes multi-threaded execution. If set to false, the value of the `saxon:threads` argument is ignored.

The default value is true if Saxon-EE is in use, false otherwise.

`ALLOW_OLD_JAVA_URI_FORMAT`

http://saxon.sf.net/feature/allow-old-java-uri-format

ALLOW_OLD_JAVA_URI_FORMAT determines whether extension function calls to dynamically-loaded Java extension functions may use the URI format supported in older Saxon releases.

If the value is false (the default), the only URI format accepted is (for example) "java:java.util.Date" - that is, a URI consisting of the string "java:" followed by the Java qualified class name of the class containing the implementation of the extension function.

If the value is true, then in addition to this format, the following are accepted: (a) the Java class name on its own ("java.util.Date"), and (b) any URI in which the Java class name follows the last "/" character (for example "http://my.com/extensions/java.util.Date"). This last format was originally provided for compatibility with xt and xalan, but it causes problems because it leads to unnecessary attempts to load spurious classes when the user did not intend the URI to represent a dynamically-loaded Java class.

`COLLATION_URI_RESOLVER` http://saxon.sf.net/feature/collation-uri-resolver | The supplied `CollationURIResolver` is used to process any collation URIs found in the query or stylesheet, returning an object of class `StringCollator` that implements the requested collation. |
`COLLATION_URI_RESOLVER_CLASS` http://saxon.sf.net/feature/collation-uri-resolver-class | The supplied class is instantiated and the resulting instance is used as the value of the `FeatureKeys#COLLATION_URI_RESOLVER` property. |
`COLLECTION_URI_RESOLVER` http://saxon.sf.net/feature/collection-uri-resolver | The supplied `CollectionURIResolver` is used to process any URIs used in calls to the `collection()` function. The `CollectionURIResolver` may either return a sequence of URIs (which are then resolved in the same way as URIs passed to the `doc()` function), or it may return a sequence of (typically document) nodes. |
`COLLECTION_URI_RESOLVER_CLASS` http://saxon.sf.net/feature/collection-uri-resolver-class | The supplied class is instantiated and the resulting instance is used as the value of the `FeatureKeys#COLLECTION_URI_RESOLVER` property. | -cr

`COMPILE_WITH_TRACING`

http://saxon.sf.net/feature/compile-with-tracing

If run-time tracing of stylesheet or query execution is required, then the code must be compiled with tracing enabled. Default is false. This option causes code to be compiled that makes calls to a `net.sf.saxon.lib.TraceListener`, but this has no effect unless a `TraceListener` is registered at execution time.

automatically set when -T is present

`CONFIGURATION`

http://saxon.sf.net/feature/configuration

This attribute cannot be set on the `net.sf.saxon.Configuration` itself, but it can be set on various JAXP factory objects such as a TransformerFactory or DocumentBuilderFactory, to ensure that several such factories use the same Configuration. Note that other configuration options are held in the Configuration object, so setting this attribute will cancel all others that have been set. Also, if two factories share the same configuration, then setting an attribute on one affects all the others.

`CONFIGURATION_FILE`

http://saxon.sf.net/feature/configuration-file

Defines a configuration file to be applied to the configuration. This attribute cannot be set on the `net.sf.saxon.Configuration` itself, but it can be set on various JAXP factory objects such as a `TransformerFactory` or `DocumentBuilderFactory`. It is particularly useful when running transformations via the Ant xslt task, where it can be set as follows to define all configuration settings:

<factory name="net.sf.saxon.TransformerFactoryImpl"> <attribute name="http://saxon.sf.net/feature/configuration-file" value="c:/saxon/config.xml"/> </factory>

-config:filename

`DEFAULT_COLLATION`

http://saxon.sf.net/feature/defaultCollation

This option determines the collation that is used for comparing strings when no explicit collation is requested. It is not necessary for this collation to exist (or to have been registered) when setting this option; it only needs to exist by the time it is used.

In XSLT it is possible to override this setting using the `[xsl:]default-collation` attribute on any stylesheet element. In XQuery, it can be overridden using the `declare default collation` declaration in the query prolog, or via a setter method in class `net.sf.saxon.query.StaticQueryContext`.

If no value is specified, the Unicode codepoint collation is used.

`DEFAULT_COLLECTION` http://saxon.sf.net/feature/defaultCollection | This determines the collection that is used when the `fn:collection()` function is called with no arguments; the effect is the same as if it were called passing the URI that is the value of this configuration property. |
`DEFAULT_COUNTRY` http://saxon.sf.net/feature/defaultCountry | This determines the country that is used by `format-date()` and similar functions if no country code is supplied explicitly. If no value is given for this property, the default is taken from the Java Locale, which in turn typically depends on settings for the current user in the operating system. |
`DEFAULT_LANGUAGE` http://saxon.sf.net/feature/defaultLanguage | This option determines the language that is used by `format-date()`, `xsl:number` and similar constructs if no language code is supplied explicitly. If no value is given for this property, the default is taken from the Java Locale, which in turn typically depends on settings for the current user in the operating system. |

`DTD_VALIDATION`

http://saxon.sf.net/feature/validation

If true, the XML parser is requested to perform validation of source documents against their DTD. Default is false.

This option establishes a default for use whenever source documents (not stylesheets or schema documents) are parsed. The option can be overridden for individual documents by setting the `net.sf.saxon.lib.ParseOptions` for that individual document, for example from a `URIResolver`.

-dtd:(on|off|recover)

`DTD_VALIDATION_RECOVERABLE`

http://saxon.sf.net/feature/dtd-validation-recoverable

This option determines whether DTD validation failures should be treated as recoverable. If the option is set, a validation failure is reported as a warning rather than an error. The default is false.

This option establishes a default for use whenever source documents (not stylesheets or schema documents) are parsed. The option can be overridden for individual documents by setting the `net.sf.saxon.lib.ParseOptions` for that individual document, for example from a `URIResolver`.

-dtd:(on|off|recover)

`ERROR_LISTENER_CLASS`

http://saxon.sf.net/feature/errorListenerClass

ERROR_LISTENER_CLASS is the name of the class used to implement the JAXP `ErrorListener`. This is used both at compile time and at run-time. Currently if this option is specified, the class is instantiated, and the same instance is used for all processes running under this configuration. This may change in future so that a new instance is created for each compilation or evaluation.

Finer control can be obtained by setting the `ErrorListener` for a specific XSLT or XQuery compilation or evaluation.

`EXPAND_ATTRIBUTE_DEFAULTS`

http://saxon.sf.net/feature/expandAttributeDefaults

EXPAND_ATTRIBUTE_DEFAULTS determines whether fixed and default values defined in a schema or DTD will be expanded (both on input and on output documents, if validation is requested). By default (and for conformance with the specification) validation against a DTD or schema will cause default values defined in the schema or DTD to be inserted into the document. Setting this feature to false suppresses this behavior. In the case of DTD-defined defaults this only works if the XML parser reports whether each attribute was specified in the source or generated by expanding a default value. Not all XML parsers report this information.

-expand:(on|off)

`LAZY_CONSTRUCTION_MODE`

http://saxon.sf.net/feature/lazyConstructionMode

LAZY_CONSTRUCTION_MODE determines whether temporary trees are constructed * lazily. The default setting is false; there are a few situations (but not many) where setting this * to true can give a performance benefit (especially a memory saving).

The option is most likely to be effective when executing XQuery in "pull" mode, that is, when the client calls the query processor to deliver the result as a stream of nodes, rather than running the query and piping the results into a serializer.

`LICENSE_FILE_LOCATION`

http://saxon.sf.net/feature/licenseFileLocation

LICENSE_FILE_LOCATION holds the filename in which the Saxon license file is held. This is the full file name, for example "c:/saxon/license/license.lic". Setting this property causes Saxon to immediately read the specified file and register the license data, assuming it can be found at this location. The property is not recognized for reading, and it is not recognized for writing except in Saxon-PE and Saxon-EE.

`LINE_NUMBERING`

http://saxon.sf.net/feature/linenumbering

Default is false. If true, line and column number information is retained for all source documents. This information is accessible using the `saxon:line-number()` and `saxon:column-number()` extension functions.

Note that the information is only as good as the XML parser supplies. SAX parsers generally report the position of an element node using the line and column number of the ">" character that forms the last character of the start tag.

-l:(on|off)

`MESSAGE_EMITTER_CLASS`

http://saxon.sf.net/feature/messageEmitterClass

Use the specified Receiver to process the output from `xsl:message`. The class must implement the `net.sf.saxon.event.Receiver` interface. This interface is similar to a SAX `ContentHandler`, in that it takes a stream of events to generate output.

By default the standard XML emitter is used, configured to write to the standard error stream, and to include no XML declaration.

In general the content of a message is an XML fragment. Each message is output as a new document. The sequence of calls to this Receiver is as follows: there is a single `open()` call at the start of the transformation, and a single `close()` call at the end; and each evaluation of an `xsl:message` instruction starts with a `startDocument()` call and ends with `endDocument()`.

The `startDocument()` event has a `properties` argument indicating whether `terminate="yes"` was specified, and the `locationId` on calls such as `startElement()` and `characters()` can be used to identify the location in the stylesheet where the message data originated (this is achieved by passing the supplied `locationId` in a call to `getPipelineConfiguration().getLocator().getSystemId(locationId)`, or to `getLineNumber()` on the same object).

Select the class `net.sf.saxon.event.MessageWarner` to have `xsl:message` output notified to the JAXP `ErrorListener`, as described in the JAXP documentation.

-m:classname

`MODULE_URI_RESOLVER` http://saxon.sf.net/feature/moduleURIResolver | Affects XQuery only. An instance of a user-written class implementing Saxon's `net.sf.saxon.lib.ModuleURIResolver` interface. This is used to process any URIs used in `import module` directives in XQuery. | -mr:classname
`MODULE_URI_RESOLVER_CLASS` http://saxon.sf.net/feature/moduleURIResolverClass | Affects XQuery only. The name of a user-written class implementing Saxon's `net.sf.saxon.lib.ModuleURIResolver` interface. This is used to process any URIs used in `import module` directives in XQuery. | -mr:classname

`NAME_POOL`

http://saxon.sf.net/feature/namePool

Indicates that the supplied `NamePool` should be used as the target (run-time) NamePool by all stylesheets compiled (using `newTemplates()`) after this call on `setAttribute`. Normally a single system-allocated `NamePool` is used for all stylesheets compiled while the Java VM remains loaded; this attribute allows user control over the allocation of name pools. Note that source trees used as input to a transformation must be built using the same `NamePool` that is used when the stylesheet is compiled: this will happen automatically if the input to a transformation is supplied as a `SAXSource` or `StreamSource` but it is under user control if you build the source tree yourself.

`OCCURRENCE_LIMITS`

http://saxon.sf.net/feature/occurrenceLimits

OCCURRENCE_LIMITS determines the largest values of `minOccurs` and `maxOccurs` that can be accommodated when compiling an "expanded" finite state machine to represent an XSD content model grammar. These limits do not apply in the common cases where the grammar can be implemented using a counting finite-state-machine, but in those cases where this is not possible, any `minOccurs` value greater than the first integer is reduced to the value of the first integer, and any `maxOccurs` value greater than the second integer is treated as "unbounded".

-limits:min,max

`OPTIMIZATION_LEVEL`

http://saxon.sf.net/feature/optimizationLevel

A string whose value is an integer in the range 0 (no optimization) to 10 (full optimization); currently all values other than 0 result in full optimization but this is likely to change in future. The default is full optimization; this feature allows optimization to be suppressed in cases where reducing compile time is important, or where optimization gets in the way of debugging, or causes extension functions with side-effects to behave unpredictably. (Note however, that even with no optimization, lazy evaluation may still cause the evaluation order to be not as expected.)

-opt:integer

`OUTPUT_URI_RESOLVER` http://saxon.sf.net/feature/outputURIResolver | The supplied `OutputURIResolver` will be used to resolve URIs of secondary result documents selected in the `href` attribute of the `xsl:result-document` instruction |
`OUTPUT_URI_RESOLVER_CLASS` http://saxon.sf.net/feature/outputURIResolverClass | The supplied class will be instantiated, and the resulting `OutputURIResolver` will be used to resolve URIs of secondary result documents selected in the `href` attribute of the `xsl:result-document` instruction | -or:classname

`PRE_EVALUATE_DOC_FUNCTION`

http://saxon.sf.net/feature/preEvaluateDocFunction

If true, calls on the `doc()` and `document()` functions, if their arguments are known at compile time, will be evaluated at compile time, and the resulting document will be stored as part of the Saxon `net.sf.saxon.Configuration` and shared by all queries and transformations running within that `Configuration`. This is useful for reference documents that have stable content and are used by many different queries and transformations. The default is false, which means each query or transformation will reload the document from disk.

`PREFER_JAXP_PARSER`

http://saxon.sf.net/feature/preferJaxpParser

This option has no effect on the Java platform. The default is true. When running on the .NET platform, if the option is true it causes the Apache Xerces parser (cross-compiled using IKVMC) to be used in preference to the .NET XML parser. If false the .NET XML parser (`System.Xml.XmlTextReader`) is used. One reason for using this option is that the .NET XML parser does not report ID attributes, which means that the id() function does not work.

`RECOGNIZE_URI_QUERY_PARAMETERS`

http://saxon.sf.net/feature/recognize-uri-query-parameters

True if the the standard URI resolver is to recognize query parameters included in the URI (for example, `?val=strict`). Such parameters can then be used in URIs passed to the `doc()` or `document()` functions. For details of the query parameters available, see Source Documents. The default is false.

This option has no effect if a user-supplied `URIResolver` is in use, unless the user-supplied `URIResolver` chooses to inherit this functionality from the standard `URIResolver`.

Allowed parameters include `validation=strict|lax|strip` to perform schema validation, `strip-space=yes|ignorable|no` to control whitespace stripping, and `xinclude=yes|no` to control whether XInclude processing takes place (assuming the XML parser supports it).

`RECOVERY_POLICY`

http://saxon.sf.net/feature/recoveryPolicy

An Integer, one of `net.sf.saxon.Configuration#RECOVER_SILENTLY`, `net.sf.saxon.Configuration#RECOVER_WITH_WARNINGS`, or `net.sf.saxon.Configuration#DO_NOT_RECOVER`. Indicates the policy for handling dynamic errors that the XSLT specification defines as recoverable. 0 means recover silently; 1 means recover after signalling a warning to the `ErrorListener`; 2 means treat the error as fatal. An example of a recoverable error is when two template rules match the same node.

-warnings:(silent|recover|fatal)

`RECOVERY_POLICY_NAME`

http://saxon.sf.net/feature/recoveryPolicyName

Indicates the policy for handling dynamic errors that the XSLT specification defines as recoverable. "recoverSilently" means recover silently; "recoverWithWarnings" means recover after signalling a warning to the `ErrorListener`; "doNotRecover" means treat the error as fatal. An example of a recoverable error is when two template rules match the same node.

-warnings:(silent|recover|fatal)

`SCHEMA_URI_RESOLVER` http://saxon.sf.net/feature/schemaURIResolver | The supplied `SchemaURIResolver` will be used to resolve URIs of schema documents referenced in `xsl:import-schema` declarations in XSLT, `import schema` in XQuery, references from one schema document to another using `xs:include` or `xs:import`, and references from an instance document to a schema using `xsi:schemaLocation`. |
`SCHEMA_URI_RESOLVER_CLASS` http://saxon.sf.net/feature/schemaURIResolverClass | The name of a class that implements the interface `SchemaURIResolver`; this class will be instantiated and the resulting instance will be used as the value of the `FeatureKeys#SCHEMA_URI_RESOLVER` property. |
`SCHEMA_VALIDATION` http://saxon.sf.net/feature/schema-validation | Indicates whether and how schema validation should be applied to source documents. | -val:(strict|lax|strip|preserve)
`SCHEMA_VALIDATION_MODE` http://saxon.sf.net/feature/schema-validation-mode | Indicates whether and how schema validation should be applied to source documents. | -val:(strict|lax|strip|preserve)

`SERIALIZER_FACTORY_CLASS`

http://saxon.sf.net/feature/serializerFactoryClass

The class will be instantiated and the resulting `SerializerFactory` will be used to create the serialization pipeline for XSLT and XQuery results. By subclassing the standard `SerializerFactory` it is possible to customize many aspects of the output produced by the Serializer, or to introduce new serialization methods and parameters.

`SOURCE_PARSER_CLASS` http://saxon.sf.net/feature/sourceParserClass | The class will be instantiated and the resulting `XMLReader` will be used to parse source documents (that is, the principal source document plus any secondary source documents read using the `doc()`, `document()`, or `collection()` function) | -x:classname

`SOURCE_RESOLVER_CLASS`

http://saxon.sf.net/feature/sourceResolverClass

On interfaces that allow a `org.xml.sax.Source` to be supplied, if a kind of `Source` is provided that Saxon does not recognize, it will be passed to the user-supplied `SourceResolver`, which has the opportunity to convert it to a kind of `Source` that Saxon does recognize. This allows new kinds of input to be supplied as input to Saxon's query, transformation, and validation engines.

`STANDARD_ERROR_OUTPUT_FILE`

http://saxon.sf.net/feature/standardErrorOutputFile

STANDARD_ERROR_OUTPUT_FILE is the name of a file to which Saxon will redirect output that would otherwise go to the operating system standard error stream (System.err). This is the fallback destination for various tracing and diagnostic output. In some cases a more specific mechanism exists to select the destination for particular kinds of output.

Note that this property is write-only, and cannot be set from the configuration file.

`STRIP_WHITESPACE`

http://saxon.sf.net/feature/strip-whitespace

Indicates whether all whitespace, no whitespace, or whitespace in elements defined in a DTD or schema as having element-only content should be stripped from source documents. The default is "ignorable". This whitespace stripping is additional to any stripping done as a result of the `xsl:strip-space` declaration in an XSLT stylesheet.

-strip:(all|none|ignorable)

`STYLE_PARSER_CLASS` http://saxon.sf.net/feature/sourceParserClass | The class will be instantiated, and the resulting `XMLReader` will be used to parse stylesheet documents (that is, the principal stylesheet module plus any secondary source documents read using xsl:include or xsl:import) and also schema documents. | -y:classname
`TIMING` http://saxon.sf.net/feature/timing | This is set to true to cause basic timing and tracing information is to be output to the standard error output stream. The name of the feature is poorly chosen, since much of the information that is output has nothing to do with timing, for example the names of output files for `xsl:result-document` are traced. | -t
`TRACE_EXTERNAL_FUNCTIONS` http://saxon.sf.net/feature/trace-external-functions | If this option is set, Saxon will output (to the standard error output) progress information about its attempts to locate and disambiguate references to reflexive Java extension functions. This is useful for diagnostics if the XQuery or XSLT compiler is failing to locate user-written extension functions. | -TJ

`TRACE_OPTIMIZER_DECISIONS`

http://saxon.sf.net/feature/trace-optimizer-decisions

If this option is set, Saxon will output (to the standard error output) detailed information about the rewrites to the expression tree made by the optimizer. This information is mainly useful for internal system debugging, but it is also possible to digest it to analyze the ways in which the expression has been optimized for the purpose of performance analysis and tuning.

-explain

`TRACE_LISTENER`

http://saxon.sf.net/feature/traceListener

The `TraceListener` will be notified of significant events occurring during a query or transformation, for tracing or debugging purposes.

Setting a `TraceListener` automatically sets the `FeatureKeys#COMPILE_WITH_TRACING` option.

Avoid this option if more than one transformation or query is running concurrently: use the feature `FeatureKeys#TRACE_LISTENER_CLASS` instead. Alternatively, it is possible to set a `TraceListener` for an individual query or transformation.

-TL:classname

`TRACE_LISTENER_CLASS`

http://saxon.sf.net/feature/traceListenerClass

The class will be instantiated once for each query or transformation, and the resulting `TraceListener` will be notified of significant events occurring during that query or transformation, for tracing or debugging purposes.

Setting a `TraceListener` automatically sets the `FeatureKeys#COMPILE_WITH_TRACING` option.

-TL:classname

`TREE_MODEL` http://saxon.sf.net/feature/treeModel | Selects an implementation of the Saxon tree model. The default is `TINY_TREE`. For running XQuery Update, use the linked tree, because it is the only implementation that is updateable. | -tree:(linked|tiny|tinyc)
`TREE_MODEL_NAME` http://saxon.sf.net/feature/treeModelName | Selects an implementation of the Saxon tree model. The default is `tinyTree`. For running XQuery Update, use the linked tree, because it is the only implementation that is updateable. | -tree:(linked|tiny|tinyc)
`URI_RESOLVER_CLASS` http://saxon.sf.net/feature/uriResolverClass | An instance of the specified `URIResolver` class will be created, and used to resolve (dereference) all URIs specifed in calls to the `doc()` and `document()` functions, as well as URIs used in `xsl:include` and `xsl:import` and location hints for XQuery modules and XSD schema documents. | -r:classname

`USE_PI_DISABLE_OUTPUT_ESCAPING`

http://saxon.sf.net/feature/use-pi-disable-output-escaping

This option determines whether a `TransformerHandler` created with this `TransformerFactory` or `Configuration` recognizes the JAXP-defined processing instructions `Result.PI_DISABLE_OUTPUT_ESCAPING` and `Result.PI_ENABLE_OUTPUT_ESCAPING` in the input stream as instructions to disable or to re-enable output escaping. The default value is false.

`USE_TYPED_VALUE_CACHE`

http://saxon.sf.net/feature/use-typed-value-cache

This option is relevant only when the TinyTree is used; it determines whether (for a validated document) a cache will be maintained containing the typed values of nodes. Typed values are held in the cache only for elements and attributes whose type is other than string, untypedAtomic, or anyURI. The default value is true. Setting this value to false can reduce memory requirements at the cost of requiring recomputation of typed values on each access.

`USE_XSI_SCHEMA_LOCATION`

http://saxon.sf.net/feature/useXsiSchemaLocation

This option determines whether or not to use the `xsi:schemaLocation` and`xsi:noNamespaceSchemaLocation` attributes in an instance document to locate a schema for validation.

Note, these attribute are only consulted if validation is requested; the presence of one of these attributes never by itself triggers validation.

-xsiloc:(on|off)

`VALIDATION_COMMENTS` http://saxon.sf.net/feature/validation-comments | This option determines whether non-fatal validation errors in XQuery or XSLT result documents should result in comments being inserted into the result tree. The command-line flag `-outval:recover` sets both this option and the `FeatureKeys#VALIDATION_WARNINGS` option. | -outval:recover

`VALIDATION_WARNINGS`

http://saxon.sf.net/feature/validation-warnings

This option indicates (if true) that errors occuring while validating a final result tree are to be treated as warnings rather than fatal errors. Although the XSLT and XQuery specifications state that validation errors are fatal, this switch can be useful during debugging because it enables the invalid output to be inspected.

-outval:recover

`VERSION_WARNING`

http://saxon.sf.net/feature/version-warning

Indicates whether a warning message should be notified (to the `ErrorListener`) if running Saxon against an XSLT stylesheet that specifies `version="1.0"`. The warning that an XSLT 1.0 stylesheet is being processed using an XSLT 2.0 processor is output by default (because the W3C specification requires it), but it may be suppressed using this option.

-versmsg:(on|off)

`XINCLUDE`

http://saxon.sf.net/feature/xinclude-aware

Indicates whether source documents should have any XInclude directives expanded. The default is false. The option applies to all input XML documents, including stylesheets and schema documents. It can be overridden for individual documents using the `net.sf.saxon.lib.ParseOptions` class.

This option relies on support in the underlying XML parser. If the XML parser does not support XInclude processing, the option is ignored.

-versmsg:(on|off)

`XML_VERSION`

http://saxon.sf.net/feature/xml-version

This determines the XML version used by the Configuration.

Note that source documents specifying xml version="1.0" or "1.1" are accepted regardless of this setting. The effect of this switch is to change the validation rules for types such as `xs:Name` and `xs:NCName`, to change the characters allowed in names within XPath expressions (etc.), to change the meaning of `\i` and `\c` in regular expressions, and to determine whether the serializer allows XML 1.1 documents to be constructed.

The default is currently 1.0, but may change.

-xmlversion:(1.0|1.1)

`XQUERY_ALLOW_UPDATE`

http://saxon.sf.net/feature/xqueryAllowUpdate

Determines whether XQuery Update syntax is accepted. If true, update syntax is accepted, if false, it is not accepted. Setting the value to true does not mean that the query has to use update syntax, only that it may do so.

Note that XQuery Update syntax and XQuery 3.0 syntax cannot currently be mixed.

This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default.

On the command line, this option is combined with the option "discard" which indicates that updates are allowed, but the updates are not written back to filestore. This does not correspond to any option in the Java API, where writing an updated document back to filestore only happens if explicitly requested.

-update:(on|off|discard)

`XQUERY_CONSTRUCTION_MODE` http://saxon.sf.net/feature/xqueryConstructionMode | This option defines the default value of the construction mode in the XQuery static context (overridable in the query prolog) This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_DEFAULT_ELEMENT_NAMESPACE` http://saxon.sf.net/feature/xqueryDefaultElementNamespace | This property defines the default namespace for elements and types that are not qualified by a namespace prefix. This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_DEFAULT_FUNCTION_NAMESPACE` http://saxon.sf.net/feature/xqueryDefaultFunctionNamespace | This property defines the default namespace for function names that are not qualified by a namespace prefix. This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_EMPTY_LEAST` http://saxon.sf.net/feature/xqueryEmptyLeast | This property defines how the empty sequence is handled in XQuery sorting (the "order by" clause). If true, () comes at the start of the sorted sequence; if false, it comes last. This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_INHERIT_NAMESPACES` http://saxon.sf.net/feature/xqueryInheritNamespaces | This property defines the default value of the inherit-namespaces property in the XQuery static context. This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_PRESERVE_BOUNDARY_SPACE` http://saxon.sf.net/feature/xqueryPreserveBoundarySpace | This property defines whether "boundary space" (insignificant space in direct element constructors) should be retained or not This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_PRESERVE_NAMESPACES` http://saxon.sf.net/feature/xqueryPreserveNamespaces | This property defines whether unused namespace declarations are retained by XQuery element copy operations This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |
`XQUERY_REQUIRED_CONTEXT_ITEM_TYPE` http://saxon.sf.net/feature/xqueryRequiredContextItemType | This property defines the default expected context item type for a query. This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default. |

`XQUERY_SCHEMA_AWARE`

http://saxon.sf.net/feature/xquerySchemaAware

A query will automatically be schema-aware if it contains an `import schema` declaration. This property allows a query to be marked as schema-aware even if it contains no `import schema` declaration. It is necessary for a query to be compiled as schema-aware if it is to handle typed (validated) input documents in which nodes have type annotations based on their schema-defined type.

This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default.

`XQUERY_STATIC_ERROR_LISTENER_CLASS`

http://saxon.sf.net/feature/xqueryStaticErrorListenerClass

The specified class is instantiated to create an `ErrorListener`, and all reports of static errors in a query will go to this `ErrorListener`.

This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default.

In the absence of this property, the global `ErrorListener` specified as the value of the `#ERROR_LISTENER_CLASS` property is used.

`XQUERY_VERSION`

http://saxon.sf.net/feature/xqueryVersion

This property determines the version of XQuery used by the Configuration. In order to use XQuery 3.0, it is necessary both to set the XQuery compiler to process XQuery 3.0, and to specify XQuery 3.0 in the query prolog of each module that uses XQuery 3.0 features.

This option can be set for a particular XQuery compilation. When the option is set at the `Configuration` level, it acts as a default.

Note that XQuery 3.0 features cannot be used with XQuery Update.

XQuery 3.0 is supported only in Saxon EE.

`XSD_VERSION` http://saxon.sf.net/feature/xsd-version | This property determines the version of XML Schema used by the Configuration. The default is XSD 1.0. If XSD 1.0 is selected, XSD 1.1 features will be rejected, with the exception of the version control attributes that allow sections of the schema to be marked as requiring XSD 1.0 or XSD 1.1. |
`XSLT_INITIAL_MODE` http://saxon.sf.net/feature/initialMode | This property indicates the name of a mode within a stylesheet in which execution (using template rules) should begin This option can be set for a particular XSLT transformation. When the option is set at the `Configuration` (or on a `TransformerFactory`), it acts as a default. | -im:mode-name
`XSLT_INITIAL_TEMPLATE` http://saxon.sf.net/feature/initialTemplate | This property indicates the name of a named template within a stylesheet where execution should begin This option can be set for a particular XSLT transformation. When the option is set at the `Configuration` level (or on a `TransformerFactory`), it acts as a default. | -it:template-name

`XSLT_SCHEMA_AWARE`

http://saxon.sf.net/feature/xsltSchemaAware

This property indicates whether stylesheets should be compiled with the ability to handle schema-typed input documents. By default a stylesheet is compiled to handle such input if it contains an `xsl:import-schema` instruction, and not otherwise. It is necessary for a stylesheet to be compiled as schema-aware if it is to handle typed (validated) input documents in which nodes have type annotations based on their schema-defined type.

This option can be set for a particular XSLT compilation. When the option is set at the `Configuration` level (or on a `TransformerFactory`), it acts as a default.

`XSLT_STATIC_ERROR_LISTENER_CLASS`

http://saxon.sf.net/feature/stylesheetErrorListener

The specified class is instantiated to create an `ErrorListener`, and all reports of static errors in a stylesheet will go to this `ErrorListener`.

This option can be set for a particular XSLT compilation. When the option is set at the `Configuration` level (or on a `TransformerFactory`), it acts as a default.

In the absence of this property, the global `ErrorListener` specified as the value of the `#ERROR_LISTENER_CLASS` property is used.

`XSLT_STATIC_URI_RESOLVER_CLASS`

http://saxon.sf.net/feature/stylesheetURIResolver

This property defines a `URIResolver` used when dereferencing the URIs that appear in the `href` attributes of the `xsl:include` and `xsl:import` declarations. Note that this defaults to the setting of the global `URI_RESOLVER` property.

This option can be set for a particular XSLT compilation. When the option is set at the `Configuration` level (or on a `TransformerFactory`), it acts as a default.

In the absence of this property, the global `URIResolver` specified as the value of the `#URI_RESOLVER_CLASS` property is used.

-r:classname

`XSLT_VERSION` http://saxon.sf.net/feature/xsltVersion | This property determines the version of XSLT to be supported by default XSLT 3.0 is supported only in Saxon EE. If no value is specified for the property, an XSLT 2.0 or XSLT 3.0 processor is used depending on the value of the `version` attribute of the `xsl:stylesheet` element. | -xsltversion:(2.0|3.0)